#import "Mine.h"
#import "MineView.h"

@implementation Mine

- (id)initMine:(NSImage *)image :(MineView *)view :(NSPoint)pos
{
    self = [super init];
    
    mineImage = image;
    mineView = view;
    minePos = pos;
    mState = Mine_Button;
    flag = 0;
    bomb = NO;
    fOpen = NO;
    round = 0;
    
    return self;
}

- (void)init
{
    mState = Mine_Button;
    flag = 0;
    bomb = NO;
    fOpen = NO;
    round = 0;

}

- (void)add_flag
{
    if (flag == 2)
        flag = 0;
    else
        flag = flag + 1;
}

- (void)set_flag: (int)aFlag
{
    flag = aFlag;
}

- (int)get_flag
{
    return flag;
}

- (void)set_fOpen:(BOOL)aOpen
{
    fOpen = aOpen;
}

- (BOOL)get_fOpen
{
    return fOpen;
}

- (void)set_bomb:(BOOL)aBomb
{
    bomb = aBomb;
}

- (BOOL)get_bomb
{
    return bomb;
}

- (void)add_round
{
    round = round + 1;
}

- (int)get_round
{
    return round;
}

- (void)Red_bomb
{
    mState = Mine_Red_Mine;
}

- (BOOL)Chain
{
    if ((bomb == NO) && (round == 0) && (fOpen == NO) && (flag != 1))
        return YES;
    else
        return NO;
}

- (BOOL)RedFlag
{
    if ((flag == 1) && (fOpen == NO))
        return YES;
    else
        return NO;
}

- (BOOL)batu
{
    if ((flag == 1) && bomb == NO) {
        mState = Mine_Batu;
        return YES;
    } else
        return NO;

}

- (void)Calc
{
    if (bomb == YES)
        mState = Mine_Mine;
    else {
        switch (round) {
            case 0:
                mState = Mine_0;
                break;
            case 1:
                mState = Mine_1;
                break;
            case 2:
                mState = Mine_2;
                break;
            case 3:
                mState = Mine_3;
                break;
            case 4:
                mState = Mine_4;
                break;
            case 5:
                mState = Mine_5;
                break;
            case 6:
                mState = Mine_6;
                break;
            case 7:
                mState = Mine_7;
                break;
            case 8:
                mState = Mine_8;
                break;
            default:
                mState = Mine_Button;
                break;
        }
    }
}

- (void)draw
{
    NSRect rect;
    
    rect.origin.y = MINE_SIZE;
    rect.size.width = MINE_SIZE;
    rect.size.height = MINE_SIZE;

    if (fOpen == YES) {
        switch (mState) {
            case Mine_Button:
                rect.origin.x = MINE_BUTTON;
                break;
            case Mine_Flag:
                rect.origin.x = MINE_FLAG;
                break;
            case Mine_Question:
                rect.origin.x = MINE_QUESTION;
                break;
            case Mine_Mine:
                rect.origin.x = MINE_MINE;
                break;
            case Mine_Red_Mine:
                rect.origin.x = MINE_RED_MINE;
                break;
            case Mine_Batu:
                rect.origin.x = MINE_BATU;
                break;
            case Mine_0:
                rect.origin.x = MINE_0;
                rect.origin.y = 0;
                break;
            case Mine_1:
                rect.origin.x = MINE_1;
                rect.origin.y = 0;
                break;
            case Mine_2:
                rect.origin.x = MINE_2;
                rect.origin.y = 0;
                break;
            case Mine_3:
                rect.origin.x = MINE_3;
                rect.origin.y = 0;
                break;
            case Mine_4:
                rect.origin.x = MINE_4;
                rect.origin.y = 0;
                break;
            case Mine_5:
                rect.origin.x = MINE_5;
                rect.origin.y = 0;
                break;
            case Mine_6:
                rect.origin.x = MINE_6;
                rect.origin.y = 0;
                break;
            case Mine_7:
                rect.origin.x = MINE_7;
                rect.origin.y = 0;
                break;
            case Mine_8:
                rect.origin.x = MINE_8;
                rect.origin.y = 0;
                break;
            default:
                rect.origin.x = 0;
                rect.origin.y = MINE_SIZE;
                break;
        }
    } else {
        switch(flag) {
            case 0:
                rect.origin.x = MINE_BUTTON;
                rect.origin.y = MINE_SIZE;
                break;
            case 1:
                rect.origin.x = MINE_FLAG;
                rect.origin.y = MINE_SIZE;
                break;
            case 2:
                rect.origin.x = MINE_QUESTION;
                rect.origin.y = MINE_SIZE;
                break;
            default:
                rect.origin.x = MINE_BUTTON;
                rect.origin.y = MINE_SIZE;
                break;
        }
    }
    
    [mineView lockFocus];
    [mineImage compositeToPoint: minePos fromRect: rect operation:NSCompositeSourceOver];
    [mineView unlockFocus];
 //   [[mineView window] flushWindow];
}

@end
